/* Copyright (c) 1994-1996 David Hogan, see README for licence details */

#define	trace(s, c, e)

/* main.c */
extern int have_shape;

void	usage();
void	initscreen();
ScreenInfo *getscreen();
Time	timestamp();
void	sendcmessage();
void	sendconfig();
void	sighandler();
void	getevent();
void	cleanup();
unsigned long getcolour (char *name, int i);

/* event.c */
void	mainloop();
void	configurereq();
void	mapreq();
void	circulatereq();
void	unmap();
void	newwindow();
void	destroy();
void	clientmesg();
void	cmap();
void	property();
void	shapenotify();
void	enter();
void	focusin();
void	reparent();
#ifdef SHAPE
void handle_shape_event();
#endif

/* manage.c */
int 	manage();
void	scanwins();
void	setshape();
void	withdraw();
void	gravitate();
void	cmapfocus();
void	cmapnofocus();
void	getcmaps();
int 	_getprop();
char	*getprop();
Window	getwprop();
int 	getiprop();
int 	getstate();
void	mysetstate();
void	setlabel();
void	getproto();
void	gettrans();

/* menu.c */
void	button();
void	spawn( ScreenInfo * );
void	spawn_netscape( ScreenInfo * );
void	reshape();
void	move();
void	resize();
void	delete();
void	hide();
void	unhide();
void	unhidec();
void	renamec();

/* client.c */
void	setactive();
void	draw_border();
void	active();
void	nofocus();
void	top();
Client	*getclient();
void	rmclient( Client *c );
void	dump_revert();
void	dump_clients();
void	cycle (int raise);
#ifdef SHAPE
void    set_shape( Client *c );
#endif

/* grab.c */
int 	menuhit();
Client	*selectwin();
int 	sweep();
int 	drag();
void	getmouse();
void	setmouse();

/* error.c */
int 	handler();
void	fatal();
void	graberror();
void	showhints();
void	dotrace();

/* cursor.c */
void	initcurs();

/* keys.c */
void initkeys (void);
void key (XKeyEvent *e);
void grabkeys (Client *c);

/* workspace.c */
void workspace_init( void );
void workspace_more( void );
void workspace_less( void );
int  workspace_mapped( Client *s );
void workspace_delete( Client *s );
void workspace_hide( Client *s );
void workspace_unhide( Client *s );
void set_workspace_from_client( Client *c );
void workspace_save( int, int );
void workspace_restore( int );
void set_workspace( int );
void prev_workspace( void );
void next_workspace( void );

/* btarc.c */
int btarc( void );
