#ifndef _VECTOR_H
#define _VECTOR_H

typedef struct {
  int size;
  int max;
  void **data;
} VECTOR;

typedef int (*VECTOR_CALLBACK)( void *, void * );

VECTOR *vector_init( void );
void vector_destroy( VECTOR *v, VECTOR_CALLBACK c_func, void *c_data );
int vector_iterate( VECTOR *v, VECTOR_CALLBACK c_func, void *c_data );
int vector_len( VECTOR *v );

int vector_find( VECTOR *v, void *data );

void vector_push( VECTOR *v, void *data );
void *vector_pop( VECTOR *v );

void *vector_at( VECTOR *v, int pos );
void vector_replace_at( VECTOR *v, int pos, void *data );
void vector_del_at( VECTOR *v, int pos );
void vector_del( VECTOR *v, void *data );

int vector_cycle( VECTOR *v, int pos );

#endif
