#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "xalloc.h"

void *xcalloc( int size ) {
	void *p = calloc( size, 1 );
	if( !p ) {
		perror( "Alloc" );
		exit( 1 );
	}
	return( p );
}

void *xmalloc( int size ) {
	void *p = malloc( size );
	if( !p ) {
		perror( "Malloc" );
		exit( 1 );
	}
	return( p );
}

void *xrealloc( void *ptr, int size ) {
	void *p = realloc( ptr, size );
	if( !p ) {
		perror( "Realloc" );
		exit( 1 );
	}
	return( p );
}

void xfree( void *p ) {
	free( p );
}
